package main

import (
	"Study/src/study/day9Interface/Practice/comm"
	"fmt"
	"reflect"
	"sort"
)

// 很多图形界面提供了一个有状态的多重排序表格插件：
// 主要的排序键是最近一次点击过列头的列，第二个排序键是第二最近点击过列头的列，等等。
// 定义一个sort.Interface的实现用在这样的表格中。
// 比较这个实现方式和重复使用sort.Stable来排序的方式。

// 1. 定义数据
// 2. 实现sort.Interface
// 3. 实现可复用的排序方法
// 4. 实现点击一栏就对一栏排序

// 1. 定义数据类型

func main() {
	// 构建数据
	data := comm.PersonSlice{
		{"a", 1, true, 1},
		{"b", 2, false, 2},
		{"c", 3, true, 3},
		{"d", 4, false, 4},
		{"e", 5, true, 5},
		{"f", 6, false, 6},
		{"g", 7, true, 7},
	}
	// 排序
	sort.Slice(data, func(i, j int) bool {
		return data.Less(i, j, "Sex")
	})
	// 输出
	for _, v := range data {
		fmt.Println(v)
	}

	// 尝试使用反射解决，可是发现不会，233333
	t, b := reflect.TypeOf(data[1]).FieldByName("Name")
	fmt.Println(t, b)
}
